package me.hammerle.console;

import java.awt.Color;
import java.awt.Font;
import javax.swing.JScrollBar;
import javax.swing.JScrollPane;
import javax.swing.JTextPane;
import javax.swing.text.BadLocationException;
import javax.swing.text.Style;
import javax.swing.text.StyleConstants;
import javax.swing.text.StyledDocument;

public class BlackBox extends JScrollPane
{
    private final StyledDocument doc;
    protected final JTextPane area;
    protected final Console c;
    
    public BlackBox(Console c)
    {
        this.c = c;
        
        area = new JTextPane();
        //area.setLineWrap(true);
        area.setBackground(Color.black);
        area.setFont(new Font("Monaco", Font.PLAIN, 16));
        area.setForeground(Color.white);
        area.setCaretColor(Color.white);
        area.setAutoscrolls(true);
        
        super.setViewportView(area);
        super.setBackground(Color.black);
        super.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
        
        doc = area.getStyledDocument();
    }
    
    public void append(String s, Color c)
    {
        Style style = null;
        if(c != null)
        {
            style = doc.getStyle(s);
            if(style == null)
            {
                style = area.addStyle(c.toString(), null);
                StyleConstants.setForeground(style, c);
            }
        }
        try 
        {
            doc.insertString(doc.getLength(), s, style);
        } 
        catch (BadLocationException ex) 
        {
        }
        scrollToBottom();
    }
    
    protected void scrollToBottom()
    {
        JScrollBar v = this.getVerticalScrollBar();
        v.setValue(v.getMaximum());
    }
}
